{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "artefact"|capfirst %}{% endblock %}
{% block content %}
  <div class="row mt-2">
    <div class="col-12">
      <h1 class="text-center">
        <i class="bi bi-upc"></i> {{ object.rescue_number }}
        {% if object.composed_object %}
          <i class="bi {{ object.icon }} float-end"></i>
        {% endif %}
      </h1>
      {% if object.hazard %}
        <!-- Display hazard icon and name -->
        <h5 class="text-center text-danger">{{ object.hazard.name|capfirst }}</h5>
        <p class="text-center text-danger"><i class="h1 bi {{ object.hazard.icon_class }}"></i></p>
      {% endif %}
    </div>
  </div>
 <div class="row mt-3">
  <div class="col-md-6 mb-3">
    {% if object.images.count > 0 %}
      <div id="artefactCarousel" class="carousel slide" data-bs-ride="false" data-bs-interval="false">
        <div class="carousel-indicators">
          {% for asset in object.images.all %}
            {% if asset.image %}
            <button type="button" data-bs-target="#artefactCarousel" data-bs-slide-to="{{ forloop.counter0 }}"
                    {% if asset.default %}class="active"{% endif %} aria-current="true"
                    aria-label="Slide {{ forloop.counter }}"></button>
            {% endif %}
          {% endfor %}
        </div>
        <div class="carousel-inner">
          {% for asset in object.images.all %}
            {% if asset.image %}
            <div class="carousel-item {% if asset.default %}active{% endif %}">
              <img src="{{ asset.image.url }}" class="d-block w-100" alt="{{ object.name }}">
              <div class="carousel-caption d-none d-md-block">
                <p>{{ asset.description }}</p>
              </div>
            </div>
            {% endif %}
          {% endfor %}
        </div>
        <button class="carousel-control-prev" type="button" data-bs-target="#artefactCarousel" data-bs-slide="prev">
          <span class="carousel-control-prev-icon" aria-hidden="true"></span>
          <span class="visually-hidden">Previous</span>
        </button>
        <button class="carousel-control-next" type="button" data-bs-target="#artefactCarousel" data-bs-slide="next">
          <span class="carousel-control-next-icon" aria-hidden="true"></span>
          <span class="visually-hidden">Next</span>
        </button>
      </div>
    {% endif %}
  </div>
  <div class="col-md-6">
    <div class="mb-3">
      <label class="form-label">{% translate "type"|capfirst %}</label>
      <p class="form-control">{{ object.artefact_type }}</p>
    </div>
    <div class="mb-3">
      <label class="form-label">{% translate "designation"|capfirst %}</label>
      <p class="form-control">{{ object.name }}</p>
    </div>
    <div class="mb-3">
      <label class="form-label">{% translate "inventory number"|capfirst %}</label>
      <p class="form-control">{{ object.inventory_number }}</p>
    </div>
    <div class="mb-3">
      <label class="form-label">{% translate "damages"|capfirst %}</label>
      <div class="input-group align-items-stretch align-items-center">
      {% if object.damage_level %}
        <p class="input-group-text damage-level-{{ object.damage_level.level }}">{{ object.damage_level.label }}</p>
      {% else %}
        <p class="input-group-text">None</p>
      {% endif %}
        <p class="form-control border-right-0">
          {% for damage_assessment in added_damages %}
              {% if damage_assessment.timestamp_remove is None %}
                <span class="badge bg-secondary">
                  <i class="{{ damage_assessment.damage_type.icon_class }}"></i>
                  {{ damage_assessment.damage_type.name }}</span>
              {% endif %}
            {% endfor %}
        </p>
        {% if perms.artefacts.view_damageassessment %}
            <p class="input-group-text bg-white" type="button" data-bs-toggle="modal"
               data-bs-target="#AssessmentHistoyModal"><i class="bi bi-eye"></i></p>
        {% endif %}
      </div>
    </div>
    <div class="mb-3">
      <label class="form-label">{% translate "priority"|capfirst %}</label>
      <p class="form-control"><span class="color-box" style="background-color:{{ object.priority.color }}"></span>{{ object.priority }}</p>
    </div>
    <div class="mb-3">
      <label class="form-label">{% translate "description"|capfirst %}</label>
      <p class="form-control">{{ object.description }}</p>
    </div>
    <div class="mb-3">
      {% if perms.artefacts.add_artefactimageasset or perms.artefacts.change_artefactimageasset %}
        <a href="{% url "artefacts:take-picture" object.id %}" class="btn btn-outline-primary btn-lg mb-3 me-3"><i
          class="bi bi-camera"></i> {% translate "take picture"|capfirst %}</a>
      {% endif %}
      {% if perms.artefacts.change_artefact %}
        <a href="{% url "artefacts:change" object.id %}" class="btn btn-outline-primary btn-lg mb-3 me-3"><i
          class="bi bi-pencil"></i> {% translate "update"|capfirst %}</a>
      {% endif %}
      {% if perms.artefacts.add_damageassessment or perms.artefacts.change_damageassessment %}
        <a href="{% url "artefacts:change-damage" object.id %}"
           class="btn btn-outline-primary btn-lg mb-3 me-3">{% translate "assess damage"|capfirst %}</a>
      {% endif %}
      {% if perms.artefacts.add and not object.parent %}
        <button type="button" class="btn btn-outline-primary btn-lg mb-3 me-3" data-bs-toggle="modal" data-bs-target="#createChildModal">
          {% translate "create part"|capfirst %}
        </button>
      {% endif %}
    </div>
    {% if object.existing_collection %}
      <div class="mb-3">
        <div class="row">
          <div class="col">
            <label class="form-label">{% translate "Data based on"|capfirst %}</label>
          </div>
        </div>
        <div class="row">
          <div class="col">
            <button type="button" class="btn btn-outline-secondary btn-lg mb-3 me-3"
                    data-bs-toggle="popover" data-bs-trigger="focus" data-bs-placement="bottom"
                    title="ID : {{ object.existing_collection.record_id }}"  data-bs-html="true"
                    data-bs-content="{{ object.existing_collection.get_info_for_popover|safe }}">
              <i class="bi bi-database-up"></i>
              ID : {{ object.existing_collection.record_id }} -
              File : {{ object.existing_collection.get_source_file }}
            </button>
          </div>
        </div>
      </div>
    {% endif %}
  </div>
  {% include 'artefacts/snippets/stabilizationmeasure_table.html' with stabilization_measures=object.stabilization_measures.all artefact=object display_add_button=True in_place=True %}
   {% if object.parent or object.children.count > 0 %}
    <div class="row mt-3">
      <div class="col-md-12">
        {% if object.parent %}
          <div class="mb-3">
            <h4>{% translate 'parent'|capfirst %}</h4>
            <hr/>
            <table class="table table-hover">
              <thead>
                <tr>
                  <th>{% translate 'rescue number'|capfirst %}</th>
                  <th>{% translate 'name'|capfirst %}</th>
                  <th>{% translate 'type'|capfirst %}</th>
                  <th>{% translate 'priority'|capfirst %}</th>
                  <th class="w-25"></th>
                </tr>
              </thead>
              <tbody>
                <tr onclick="window.location='{{ object.parent.get_absolute_url }}'">
                  <td>{{ object.parent.rescue_number }}
                    {% if object.parent.hazard %}<i class="bi {{ object.parent.hazard.icon_class }} text-danger ms-2"></i>{% endif %}
                  </td>
                  <td>{{ object.parent.name }}{% if object.parent.inventory_number %} ({{ object.parent.inventory_number }}){% endif %}</td>
                  {% if perms.artefacts.view_artefacttype %}
                    <td>{% if object.parent.artefact_type %}{{ object.parent.artefact_type }}{% endif %}</td>
                  {% endif %}
                  {% if perms.artefacts.view_prioritylevel %}
                    <td>{% if object.parent.priority %}<span class="color-box" style="background-color:{{ object.parent.priority.color }}"></span>{{ object.parent.priority }}{% endif %}</td>
                  {% endif %}
                  <td><img src="{{ object.parent.default_picture.url }}" class="img-fluid"> </td>
                </tr>
              </tbody>
            </table>
          </div>
        {% endif %}
        {% if object.children.count > 0 %}
          <div class="mb-3">
            <h4>{% translate 'children'|capfirst %}</h4>
            <hr/>
            <table class="table table-hover">
              <thead>
                <tr>
                  <th>{% translate 'rescue number'|capfirst %}</th>
                  <th>{% translate 'name'|capfirst %}</th>
                  <th>{% translate 'type'|capfirst %}</th>
                  <th>{% translate 'priority'|capfirst %}</th>
                  <th class="w-25"></th>
                </tr>
              </thead>
              <tbody>
              {% for child in object.children.all %}
                <tr onclick="window.location='{{ child.get_absolute_url }}'">
                  <td>{{ child.rescue_number }}
                    {% if child.hazard %}<i class="bi {{ child.hazard.icon_class }} text-danger ms-2"></i>{% endif %}
                  </td>
                  <td>{{ child.name }}{% if child.inventory_number %} ({{ child.inventory_number }}){% endif %}</td>
                  {% if perms.artefacts.view_artefacttype %}
                    <td>{% if child.artefact_type %}{{ child.artefact_type }}{% endif %}</td>
                  {% endif %}
                  {% if perms.artefacts.view_prioritylevel %}
                    <td>{% if child.priority %}<span class="color-box" style="background-color:{{ child.priority.color }}"></span>{{ child.priority }}{% endif %}</td>
                  {% endif %}
                  <td><img src="{{ child.default_picture.url }}" class="img-fluid"> </td>
                </tr>
              {% endfor %}
              </tbody>
            </table>
          </div>
        {% endif %}
      </div>
    </div>
  </div>
  {% endif %}
  {% include 'activities/action_object.html' with activities=object.action_object_actions.all %}
{% endblock %}

{% block modal %}
  {% if object.hazard %}
    <div class="modal" id="hazard" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header bg-danger">
            <h5 class="modal-title">{{ object.hazard.name|capfirst }}</h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            <p class="text-center text-danger"><i class="h1 bi {{ object.hazard.icon_class }}"></i></p>
            <p>{{ object.hazard.warning }}</p>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  {% endif %}

  <!-- Assessment Modal -->
  <div class="modal fade" id="AssessmentHistoyModal" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">{{ "assessments"|capfirst }}</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body d-flex">
          {% include "artefacts/snippets/damageassessment_history.html" with added_damages=added_damages deleted_damages=deleted_damages %}
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Fermer</button>
        </div>
      </div>
    </div>
  </div>
  <!-- End Assessment Modal -->
  <!-- Create Part Modal -->
  <div class="modal fade" id="createChildModal" tabindex="-1" aria-labelledby="createChildModalLabel" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="createChildModalLabel">{% translate "Create Part"|capfirst %}</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
          <div class="container">
            <div class="row justify-content-around">
              {% if object.composed_object != artefact.COMPOSED_CHOICES.1.0 %}
                <div class="col-5 col align-self-center">
                  <button id="composed-object-button" class="btn btn-outline-primary btn-rounded btn-custom mb-3 mt-3" onclick="createChild('{{ artefact.COMPOSE }}')">
                    <span>{% translate "composed object"|capfirst %}</span>
                    <img src="/static/images/ensemble-icon.svg" alt="icon compose" width="85" height="85">
                  </button>
                </div>
              {% endif %}
              {% if object.composed_object != artefact.COMPOSED_CHOICES.0.0 %}
                <div class="col-5 col align-self-center btn-custom">
                  <button id="ensemble-object-button" class="btn btn-outline-primary btn-rounded btn-custom mb-3 mt-3" onclick="createChild('{{ artefact.ENSEMBLE }}')">
                    <span>{% translate "ensemble object"|capfirst %}</span>
                    <img src="/static/images/compose-icon.svg" alt="icon ensemble" width="85" height="85">
                  </button>
                </div>
              {% endif %}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
<!-- End Create Part Modal -->

{% endblock modal %}
{% block inline_javascript %}
  <script>
    window.addEventListener('DOMContentLoaded', () => {
      // show modal if hazard is set
      if ({{ object.hazard|yesno:"1,0" }}) {
        const showHazard = new bootstrap.Modal(document.getElementById('hazard'), {
          keyboard: false
        });
        showHazard.show();
      }

      // Popover
      var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
      var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
        return new bootstrap.Popover(popoverTriggerEl)
      })
    });

    function createChild(option) {
      var parent_id = '{{ artefact.id }}'
      var url = "{% url 'barcodes:read'%}?parent_id=" + parent_id + "&option=" + option;
      window.location.href = url;
    }

  </script>
{% endblock %}
